//#define _TEMPEST_USE_FASTMATH_
//#define _TEMPEST_USE_META_

#include"../meta/type_traits.hpp"
#include"../vector/vector.hpp"
#include"../vector/vector4.hpp"
#include"../vector/vector3.hpp"
#include"../vector/vector2.hpp"
#include"../vector/safety_vector.hpp"
#include"../vector/quaternion.hpp"
#include"sse_vector.hpp"

#include<iostream>
#include<cstdlib>
#include<boost/timer.hpp>

const int num = 10000;



void func_a(){
	typedef sse_vector VECTOR;
	
	
	VECTOR array[num];
	
	for(int i = 0;i <num; i++){
		array[i] = VECTOR(rand(),rand(),rand());
	}
	
	
	
	boost::timer t;
	for(int j = 0;j <1000; j++){
		for(int i = 0;i <num; i++){		
			array[i].normalize();
		}
	}
	std::cout.width(10);
	std::cout<< t.elapsed() << std::endl;
}


template<class VECTOR>
void func_b(){
	//typedef tempest::vector<double,3> VECTOR;
	
	
	VECTOR array[num];
	
	for(int i = 0;i <num; i++){
		array[i] = VECTOR(rand(),rand(),rand());
	}
	
	
	
	boost::timer t;
	for(int j = 0;j <1000; j++){
		for(int i = 0;i <num; i++){		
			array[i].normalize();
		}
	}
	std::cout.width(10);
	std::cout<< t.elapsed() << std::endl;
}

void disp_a(){
	typedef sse_vector VECTOR;
	
	
	VECTOR array[20];
	
	for(int i = 0;i <20; i++){
		array[i] = VECTOR(rand(),rand(),rand());
		array[i].normalize();
	}
	
	
	const VECTOR * a = array;
	
	for(int i = 0;i <20; i++){
		std::cout<< a[i][0] << "," << a[i][1] << ","<<a[i][2] << ":" << a[i].length()<< "\n";	
	}
}
template<class VECTOR>
void disp_b(){
	
	VECTOR array[20];
	
	for(int i = 0;i <20; i++){
		array[i] = VECTOR(rand(),rand(),rand());
		array[i].normalize();
	}
	
	
	const VECTOR * a = array;
	
	for(int i = 0;i <20; i++){
		std::cout<< a[i][0] << "," << a[i][1] << ","<<a[i][2] << ":" << a[i].length()<< "\n";	
	}
}

int main(){
	typedef tempest::vector<double,3> DBV;
	typedef tempest::vector<float,3> FLV;
	typedef tempest::vector<long double,3> LDV;
	
	std::srand(time(0));
	/*
	func_a();
	func_b< FLV >();
	func_b< DBV >();
	func_b< LDV >();
	func_a();
	func_b< FLV >();
	func_b< DBV >();
	func_b< LDV >();
	*/
	std::cout<< "-----------" << std::endl;	
	
	disp_a();
	std::cout<< "-----------" << std::endl;	
	disp_b< FLV >();
	std::cout<< "-----------" << std::endl;	
	disp_b< DBV >();
	std::cout<< "-----------" << std::endl;	
	disp_b< LDV >();
	
}




